Bdraw_all:
     mov   ecx,BXRES * BYRES
     cld
     mov   eax,0xff1f1f1f
     mov   edi,Bbuffer
     rep   stosd

     movzx eax,word[Bipy1]
     shl   eax,16
     mov   ax,[Bipx1]
     mov   cl,0
     pushad
     call  Bputpixel
     popad


     movzx eax,[Bipy2]
     shl   eax,16
     mov   ax,[Bipx2]
     mov   cl,1
     pushad
     call  Bputpixel
     popad

     movzx eax,[Bipy3]
     shl   eax,16
     mov   ax,[Bipx3]
     mov   cl,2
     pushad
     call  Bputpixel
     popad

     movzx eax,[Bipy4]
     shl   eax,16
     mov   ax,[Bipx4]
     mov   cl,3
     pushad
     call  Bputpixel
     popad

     fninit
     fild  word[Bipx1]
     fstp  [Bp1x]
     fild  [Bipy1]
     fidiv [i3]   ; proteza
     fstp  [Bp1y]
     mov   [Bp1z],0.0

     fild  [Bipx2]
     fstp  [Bp2x]
     fild  [Bipy2]
     fidiv [i3]    ; proteza
     fstp  [Bp2y]
     mov   [Bp2z],0.0

     fild  [Bipx3]
     fstp  [Bp3x]
     fild  [Bipy3]
     fidiv [i3]      ; proteza
     fstp  [Bp3y]
     mov   [Bp3z],0.0

     fild  [Bipx4]
     fstp  [Bp4x]
     fild  [Bipy4]
     fidiv [i3]      ; proteza
     fstp  [Bp4y]
     mov   [Bp4z],0.0

     push  dword BXRES
     fild  word[Bix1_axis]
     fchs		    ; proteza
     fiadd dword[esp-4]
     fstp  dword[Bx1_axis]
     fild  [Biy1_axis]
     fstp  [By1_axis]
     mov   [Bz1_axis],0.0

     fild  word[Bix2_axis]
     fchs		    ; proteza
     fiadd dword[esp-4]
     fstp  dword[Bx2_axis]
     fild  [Biy2_axis]
     fstp  [By2_axis]
     mov   [Bz2_axis],0.0
     pop   eax

     mov   eax,[Bix1_axis]   
     mov   cl,253
     pushad
     call  Bputpixel
     popad

     mov   eax,[Bix2_axis]
     mov   cl,254
     pushad
     call  Bputpixel
     popad

     pushad
     movzx  eax,word[Bix1_axis]
     movzx  ebx,word[Biy1_axis]
     movzx  ecx,word[Bix2_axis]
     movzx  edx,word[Biy2_axis]
     mov    [screen_width_var],BXRES
     mov    [lbuffer_ptr],Bbuffer
     call   linea
     popad



     pushad
     movzx  eax,word[Bipx1]
     movzx  ebx,[Bipy1]
     movzx  ecx,[Bipx2]
     movzx  edx,[Bipy2]
     mov    [screen_width_var],BXRES
     call   linea
     popad

     pushad
     movzx  eax,[Bipx3]
     movzx  ebx,[Bipy3]
     movzx  ecx,[Bipx4]
     movzx  edx,[Bipy4]
     mov    [screen_width_var],BXRES
     call   linea
     mov    [screen_width_var],XRES
     mov    [lbuffer_ptr],buffer
     popad

     pushad
     call  draw_curve
 ;    mov   eax,[global_points_counter]
 ;    int3
     popad
ret
Bputpixel:
  emms
  mov	  ebx,(BYRES-5)*65536+BXRES-5
  movd	  mm0,ebx
  mov	  ebx,5*65536+5
  movd	  mm1,ebx
  movd	  mm2,eax
  pmaxsw  mm2,mm1
  pminsw  mm2,mm0

  movd	 eax,mm2
  mov	 edx,BXRES
  movzx  ebx,ax
  shr	 eax,16
  mul	 edx
  add	 eax,ebx
  shl	 eax,2
  add	 eax,Bbuffer

  mov	  edi,eax	       ; draw line handle
  mov	  al,cl 	       ; cl -> crucial point number
  shl	  eax,24
  cmp	  cl,253
  jae	  .axis
  or	  eax,0x00ff0000
  jmp	  .draw
 .axis:
  or	  eax,0x0000ffff
 .draw:
  sub	  edi,2*BXRES*4+20
  mov	  ecx,5
  cld
  rep	  stosd
  add	  edi,BXRES*4-20
  mov	  ecx,5
  rep	  stosd
  add	  edi,BXRES*4-20
  mov	  ecx,5
  rep	  stosd
  add	  edi,BXRES*4-20
  mov	  ecx,5
  rep	  stosd
  add	  edi,BXRES*4-20
  mov	  ecx,5
  rep	  stosd

  emms
ret